window.Gleam.initSearch([{"doc":"pinkdf2","title":"pinkdf2","content":"# pinkdf2\n\n[![Package Version](https://img.shields.io/hexpm/v/pinkdf2)](https://hex.pm/packages/pinkdf2)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/pinkdf2/)\n\nGleam bindings to the heavily-optimized [fast_pbkdf2](https://github.com/esl/fast_pbkdf2) NIF for PBKDF2 (Password-Based Key Derivation Function 2) on Erlang.\n\n```sh\ngleam add pinkdf2@1\n```\n```gleam\nimport pinkdf2\n\npub fn main() {\n  let assert Ok(key) = pinkdf2.with_defaults(&quot;password&quot;, pinkdf2.get_salt())\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/pinkdf2&gt;.\n","url":"index.html"},{"doc":"pinkdf2","title":"Pbkdf2Algorithm","content":"pub type Pbkdf2Algorithm {\n  Sha224\n  Sha256\n  Sha384\n  Sha512\n}\n\nSha224\n\n\nSha256\n\n\nSha384\n\n\nSha512\n\n\nSynonyms:\npinkdf2.Pbkdf2Algorithm\npinkdf2 Pbkdf2Algorithm","url":"pinkdf2.html#Pbkdf2Algorithm"},{"doc":"pinkdf2","title":"Pbkdf2Error","content":"pub type Pbkdf2Error {\n  IterationsValueNotPositive\n  DerivedKeyLengthValueNotPositive\n}\n\nIterationsValueNotPositive\n\n\nDerivedKeyLengthValueNotPositive\n\n\nSynonyms:\npinkdf2.Pbkdf2Error\npinkdf2 Pbkdf2Error","url":"pinkdf2.html#Pbkdf2Error"},{"doc":"pinkdf2","title":"Pbkdf2Keys","content":"pub type Pbkdf2Keys {\n  Pbkdf2Keys(raw: BitArray, base64: String)\n}\n\nPbkdf2Keys(raw: BitArray, base64: String)\n\n\nSynonyms:\npinkdf2.Pbkdf2Keys\npinkdf2 Pbkdf2Keys","url":"pinkdf2.html#Pbkdf2Keys"},{"doc":"pinkdf2","title":"get_salt","content":"pub fn get_salt() -&gt; String\n Generates a base64-encoded salt with a minimum size of 64 bytes.\n It is provided here for convenience, but it is based on the same underlying Erlang function as `crypto.strong_rand_bytes`.\nSynonyms:\npinkdf2.get_salt\npinkdf2 get_salt","url":"pinkdf2.html#get_salt"},{"doc":"pinkdf2","title":"with_config","content":"pub fn with_config(\n  alg: Pbkdf2Algorithm,\n  password: String,\n  salt: String,\n  iterations: Int,\n  d_len: Int,\n) -&gt; Result(Pbkdf2Keys, Pbkdf2Error)\n Derives a key using the provided configuration.\n\n `iterations` is the number of times to run the algorithm. Must be a positive integer.\n `d_len` is the target derived key length in bytes. Must be a positive integer.\n\n ## Examples\n\n \n import pinkdf2.{Sha512}\n\n let salt = pinkdf2.get_salt()\n let assert Ok(key) = pinkdf2.with_config(Sha512, &quot;password&quot;, salt, 210_000, 32)\n \nSynonyms:\npinkdf2.with_config\npinkdf2 with_config","url":"pinkdf2.html#with_config"},{"doc":"pinkdf2","title":"with_defaults","content":"pub fn with_defaults(\n  password: String,\n  salt: String,\n) -&gt; Result(Pbkdf2Keys, Pbkdf2Error)\n Derives a key from a password and salt with default settings based on the\n (OWASP recommendations)[https://cheatsheetseries.owasp.org/cheatsheets/Password_Storage_Cheat_Sheet.html#pbkdf2].\nSynonyms:\npinkdf2.with_defaults\npinkdf2 with_defaults","url":"pinkdf2.html#with_defaults"},{"doc":"pinkdf2","title":"pinkdf2","content":" Gleam bindings to fast_pbkdf2 NIF of PBKDF2 (Password-Based Key Derivation Function 2) for Erlang.","url":"pinkdf2.html"}]);